#ifndef _TEXTUREOBJECT_H_INCLUDED_
#define _TEXTUREOBJECT_H_INCLUDED_

#include <windows.h>
#include <d3d9.h>
#include <string>
#include "mmobject.h"

enum TextureTypes
{
	TEXTURE_SIMPLE
};

class CMMTexture : public CMMObject
{
public:
	CMMTexture() : CMMObject(), filename( L"" ), texture( NULL ) {};
	CMMTexture( LPWSTR NAME, int TAG ) : CMMObject( NAME, TAG ), 
		filename( L"" ), texture( NULL ) {};
	virtual ~CMMTexture() { CleanUp(); };
	virtual void CleanUp();
	virtual HRESULT LoadTexture( LPDIRECT3DDEVICE9 DEVICE, LPWSTR FILENAME );
	virtual LPDIRECT3DTEXTURE9 GetTexture();
	virtual std::wstring GetTextureFileName();

protected:
	std::wstring filename;
	LPDIRECT3DTEXTURE9 texture;
};

#endif // #ifndef _TEXTUREOBJECT_H_INCLUDED_